emart/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('myapp/', include("myapp.urls"), name='myappurls'),
]

myapp/urls.py
from django.urls import path
from myapp.views import home, ProductDetailView

app_name='product'

urlpatterns = [
    path('', home, name='home'),
    path('detail/<int:pk>/', ProductDetailView.as_view(), name='detail'),
]

myapp/models.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class Categary(models.TextChoices):
    PHONE = 'phone', _("Phone")
    BOOK = 'book', _("Book")


class Product(models.Model):
    title = models.CharField(max_length=30)
    price = models.IntegerField()
    dis_price = models.IntegerField()
    categary = models.CharField(choices=Categary.choices,
                                default=Categary.BOOK,
                                max_length=30)
    desc = models.TextField()
    image = models.URLField(blank=True, null=True)

    def __str__(self) -> str:
        return self.title

myapp/views.py
from django.shortcuts import render
from django.views.generic.list import ListView
from django.views.generic import DetailView
from django.db.models import Q
from .models import Product
from haystack.query import SearchQuerySet
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
# from haystack.backends.whoosh_backend import WhooshEngine



def home(request):
    product_info = request.GET.get("product_info")
    print("************", product_info)
    if product_info:
        queryset = SearchQuerySet().filter(content=product_info).exclude(content="adfadf").models(Product)

    else:
        queryset = Product.objects.all()
    if queryset:
        paginator = Paginator(queryset, 4)
        page_number = request.GET.get('page')
        try:
            page_obj = paginator.get_page(page_number)  # returns the desired page object
        except PageNotAnInteger:
            # if page_number is not an integer then assign the first page
            page_obj = paginator.page(1)
        except EmptyPage:
            # if page is empty then return last page
            page_obj = paginator.page(paginator.num_pages)
    return render(request, 'emart/list.html', {"context": page_obj})


class ProductDetailView(DetailView):
    model = Product
    template_name = 'emart/detail.html'

myapp/templates/emart/base.html
{% comment %} {% extends 'emart/navbar.html' %} {% endcomment %}
{% load static %}
{% block navs %}
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">

    <title>emart!</title>
  </head>
  <body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
      <div class="container-fluid">
        <a class="navbar-brand" href="#">Navbar</a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav me-auto mb-2 mb-lg-0">
            <li class="nav-item">
              <a class="nav-link active" aria-current="page" href="#">Home</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="#">cart</a>
            </li>
            <li class="nav-item dropdown">
              <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                Dropdown
              </a>
              <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                <li><a class="dropdown-item" href="#">Action</a></li>
                <li><a class="dropdown-item" href="#">Another action</a></li>
                <li><hr class="dropdown-divider"></li>
                <li><a class="dropdown-item" href="#">Something else here</a></li>
              </ul>
            </li>
            <li method='get' class="nav-item">
              <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Disabled</a>
            </li>
          </ul>
          <form class="d-flex">
            {% csrf_token %}
            <input name="product_info" class="form-control me-2" type="search" placeholder="Search here" aria-label="Search">
            <button class="btn btn-outline-success" type="submit">Search</button>
          </form>
        </div>
      </div>
    </nav>

    <div id="carouselExampleControls" class="carousel slide" data-bs-ride="carousel">
      <div class="carousel-inner">
        <div class="carousel-item active">
          <img src="../myapp/TestImage/images/onur-binay-d5_r6vWrkHU-unsplash.jpg" class="d-block w-100">
        </div>
        <div class="carousel-item">
          <img src="../myapp/TestImage/images/onur-binay-phQnS6PwPBI-unsplash.jpg" class="d-block w-100">
        </div>
        <div class="carousel-item">
          <img src="../myapp/TestImage/images/onur-binay-d5_r6vWrkHU-unsplash.jpg" class="d-block w-100">
        </div>
      </div>
      <button class="carousel-control-prev" type="button" data-bs-target="#carouselExampleControls" data-bs-slide="prev">
        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
        <span class="visually-hidden">Previous</span>
      </button>
      <button class="carousel-control-next" type="button" data-bs-target="#carouselExampleControls" data-bs-slide="next">
        <span class="carousel-control-next-icon" aria-hidden="true"></span>
        <span class="visually-hidden">Next</span>
      </button>
    </div>
    
    {% block body %}
    {% endblock %}



    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>

    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.2/dist/umd/popper.min.js" integrity="sha384-IQsoLXl5PILFhosVNubq5LC7Qb9DXgDA9i+tQ8Zj3iwWAwPtgFTxbJ8NT4GN1R8p" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.min.js" integrity="sha384-cVKIPhGWiC2Al4u+LWgxfKTRIcfu0JTxR+EQDz/bgldoEyl4H0zUF0QKbrJ0EcQF" crossorigin="anonymous"></script>
    -->
  </body>
</html>
{% endblock %}

myapp/templates/emart/detail.html
{% extends 'emart/base.html' %}
{% block body %}
<div class="row">
    <p>
      <div class="col-md-4 offset-md-2">
          <img class="card" height="200px" src="{{object.image}}">
      </div>
  
      <div class="col-md-3">
          <h3>Item Name: {{object.title}}</h3>
          <h3>Item Price: Rs {{.price}} </h3>
      </div>
  
      <div class="col-md-2">
        <a href="{% url 'product:home' %}" class="btn btn-success">back</a>
      </div>
      <p>
  </div>
  {% endblock %}

myapp/templates/emart/list.html
{% extends 'emart/base.html' %}
{% block body %}

{{context.objects}}
{% if context %}

<div class="card-group">
{% for i in context.object_list %}
{% comment %} <div class="row">
  <p>
    <div class="col-md-4 offset-md-2">
        <img class="card" height="200px" src="{{i.image}}">
    </div>

    <div class="col-md-3">
        <h3>Item Name: {{i.title}}</h3>
        <h3>Item Price: Rs {{i.price}} </h3>
    </div>

    <div class="col-md-2">
        <a href="{% url 'product:detail' i.pk %}" class="btn btn-success">desc</a>
    </div>
    <p>
</div> {% endcomment %}
    <div class="card" style="width: 18rem;">
        <img src="{{i.image}}" class="card-img-top" height="400px" alt="Image">
        <div class="card-body">
            <h5 class="card-title">{{i.title}}</h5>
            <p class="card-text">Item Price: Rs {{i.price}}</p>
            <a href="{% url 'product:detail' i.pk %}" class="btn btn-success">desc</a>
        </div>
    </div>
{% endfor %}
</div>
{% else %}
  <p>No results found.</p>
{% endif %}

  <center>
    {%if context.has_previous %} {# whether the previous page exists #}
        <a href="?page={{context.previous_page_number}}"><</a> {# link to the prev page #}
    {% endif %}
    <span>{{context.number}}</span> {# the current page number #}
  
    {%if context.has_next %} {# whether the next page exists #}
        <a href="?page={{context.next_page_number}}">></a> {# link to the next page #}
    {% endif %}
</center>

{% endblock %}

myapp/templates/emart/navbar.html
{% comment %} <nav class="navbar navbar-expand-lg navbar-light bg-light"> {% endcomment %}
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">
    <a class="navbar-brand" href="#">Navbar</a>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <a class="nav-link active" aria-current="page" href="#">Home</a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="#">cart</a>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
            Dropdown
          </a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
            <li><a class="dropdown-item" href="#">Action</a></li>
            <li><a class="dropdown-item" href="#">Another action</a></li>
            <li><hr class="dropdown-divider"></li>
            <li><a class="dropdown-item" href="#">Something else here</a></li>
          </ul>
        </li>
        <li method='get' class="nav-item">
          <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Disabled</a>
        </li>
      </ul>
      <form class="d-flex">
        {% csrf_token %}
        <input name="product_info" class="form-control me-2" type="search" placeholder="Search here" aria-label="Search">
        <button class="btn btn-outline-success" type="submit">Search</button>
      </form>
    </div>
  </div>
</nav>
{% block navs %}
{% endblock %}